
#include "ObservedData.h"
#include <iostream>
#include <iterator>
#include <algorithm>


bool LanguageObject::canExtract() {
    return getParent() != NULL && dynamic_cast<AggregateRelation*>(getParent()) != NULL;
    //return getParent() != NULL && dynamic_cast<AggregateRelation*>(getParent()) != NULL
    //&& !dynamic_cast<AggregateRelation*>(getParent())->minMultiplicityIsOne();
}

void LanguageObject::extract() {
    if (!canExtract()) throw VLString("Node is not extractable");
    dynamic_cast<AggregateRelation*>(getParent())->remove(this);
}


void LanguageObject::insertBefore(LanguageObject *elem) {
    if (!canExtract()) throw VLString("Cant't insert before");
    dynamic_cast<AggregateRelation*>(getParent())->insertBefore(elem,this);
}

VirtualLanguageObject *LanguageObject::getSuccessor() {
    if (!canExtract()) throw VLString("Can't get successor");
    return dynamic_cast<AggregateRelation*>(getParent())->getSuccessor(this);
}    

VirtualLanguageObject *LanguageObject::getPredecessor() {
    if (!canExtract()) throw VLString("Can't get predecessor");
    return dynamic_cast<AggregateRelation*>(getParent())->getPredecessor(this);
}    

VLList LanguageObject::getRefererList() {
    VLList result = VLList();
    std::set<ObservedRef*>::iterator p = referer->begin();
    while (p != referer->end()) {
      result.append(VLObjectPointer(*p));
      p++;
    }
    return result;
}


void EOLObject::insertBefore(LanguageObject *elem)
{
  dynamic_cast<AggregateRelation*>(getParent())->insertAtEnd(elem);
}

VirtualLanguageObject *EOLObject::getSuccessor() {
    throw VLString("EOLObject: getSuccessor called");
}    

VirtualLanguageObject *EOLObject::getPredecessor() {
    throw VLString("EOLObject: getPredecessor called");
}    




