
#ifndef _VisContainerPosition2PtrLIST_H
#define _VisContainerPosition2PtrLIST_H

/* include header file defining VisContainerPosition2Ptr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

#include "VisContainerPosition2PtrFunctionTypes.h"

typedef struct _VisContainerPosition2PtrLE *VisContainerPosition2PtrList;
typedef VisContainerPosition2PtrList    *VisContainerPosition2PtrListPtr;

struct _VisContainerPosition2PtrLE {
VisContainerPosition2Ptr                head;
VisContainerPosition2PtrList    tail;
};

#define NULLVisContainerPosition2PtrList                ((VisContainerPosition2PtrList)0)
#define NullVisContainerPosition2PtrList()      ((VisContainerPosition2PtrList)0)
#define SingleVisContainerPosition2PtrList(e)   (ConsVisContainerPosition2PtrList((e),NULLVisContainerPosition2PtrList))

#if defined(__STDC__) || defined(__cplusplus)

extern void FinlVisContainerPosition2PtrList(void);
   /* Deallocates all VisContainerPosition2PtrLists. */
   /* Dynamic storage is allocated on first need */

extern VisContainerPosition2PtrList ConsVisContainerPosition2PtrList (VisContainerPosition2Ptr e, VisContainerPosition2PtrList l);
   /* Constructs a VisContainerPosition2PtrList of an element e and a given tail l.
    * e is the first element of the list. */

extern VisContainerPosition2Ptr HeadVisContainerPosition2PtrList (VisContainerPosition2PtrList l);
   /* Returns the first element of the list l.
    * The list l must not be empty. */

extern VisContainerPosition2PtrList TailVisContainerPosition2PtrList (VisContainerPosition2PtrList l);
   /* Returns the tail of the list l.
    * If l is empty, an empty list is returned. */

extern int LengthVisContainerPosition2PtrList (VisContainerPosition2PtrList l);
   /* Returns the number of elements in the list l. */

extern VisContainerPosition2Ptr IthElemVisContainerPosition2PtrList (VisContainerPosition2PtrList l, int i);
   /* Returns the i-th element of the List l. The head of l
    * is referred to as 1. If the value of
    * i is greater than the length of the list, an error
    * is reported and the program exits.
    */

extern VisContainerPosition2PtrList CopyVisContainerPosition2PtrList (VisContainerPosition2PtrList l, VisContainerPosition2PtrMapFct cp);
   /* Copies the list l. Elements are copied by calls of cp. */

extern VisContainerPosition2PtrList AppVisContainerPosition2PtrList (VisContainerPosition2PtrList l1, VisContainerPosition2PtrList l2);
   /* Concatenates two lists l1 and l2. The resulting list contains l2 at
    * the end of a copy of list l1. */

extern VisContainerPosition2PtrList AppElVisContainerPosition2PtrList (VisContainerPosition2PtrList l, VisContainerPosition2Ptr e);
   /* Appends an element e to the list l.
    * The list l is not copied, it is modified as a side-effect
    * of this function. */

extern void InsertAfterVisContainerPosition2PtrList (VisContainerPosition2PtrList l, VisContainerPosition2Ptr e);
   /* This function requires a non-empty list l. The element e is inserted
    * just after the first element of l. 
    * The list l is modified as a side-effect of this function. */

extern VisContainerPosition2PtrList OrderedInsertVisContainerPosition2PtrList (VisContainerPosition2PtrList l, VisContainerPosition2Ptr e, VisContainerPosition2PtrCmpFctType fcmp);
   /* Inserts the element e into the list l maintaining l in
    * ascending order with respect to the compare fcmp. 
    * The list l is modified as a side-effect of this function. */

extern VisContainerPosition2PtrListPtr RefEndConsVisContainerPosition2PtrList (VisContainerPosition2PtrListPtr addr, VisContainerPosition2Ptr e);
   /* Appends an element e to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern VisContainerPosition2PtrListPtr RefEndAppVisContainerPosition2PtrList (VisContainerPosition2PtrListPtr addr, VisContainerPosition2PtrList l);
   /* Appends a list l to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern int ElemInVisContainerPosition2PtrList (VisContainerPosition2Ptr e, VisContainerPosition2PtrList l, VisContainerPosition2PtrCmpFctType cmpfct);
   /* This function returns true (1) iff the element e is in the List l.
    * List elements are compared by the function cmpfct. */

extern VisContainerPosition2PtrList AddToSetVisContainerPosition2PtrList (VisContainerPosition2Ptr e, VisContainerPosition2PtrList l, VisContainerPosition2PtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. */

extern VisContainerPosition2PtrList AddToOrderedSetVisContainerPosition2PtrList 
       (VisContainerPosition2Ptr e, VisContainerPosition2PtrList l, VisContainerPosition2PtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. l is assumed to be ordered increasingly in the sense of
    * cmpfct. */

extern VisContainerPosition2PtrList MapVisContainerPosition2PtrList (VisContainerPosition2PtrList l, VisContainerPosition2PtrMapFct f);
   /* Returns a new VisContainerPosition2PtrList obtained by applying f to each element of l. */

extern int CompVisContainerPosition2PtrList (VisContainerPosition2PtrList l1, VisContainerPosition2PtrList l2, VisContainerPosition2PtrCmpFctType f);
   /* Compares the lists l1 and l2 lexicographically by applying f
    * to the corresponding elements. */

extern VisContainerPosition2Ptr SumVisContainerPosition2PtrList (VisContainerPosition2PtrList l, VisContainerPosition2PtrSumFct f, VisContainerPosition2Ptr a);
   /* Applies the binary function f to the elements of the List:
    *   f( f(... f(a, e1), e2, ...), en)
    * If l is empty a is returned. */

#else

extern void FinlVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList ConsVisContainerPosition2PtrList ();
extern VisContainerPosition2Ptr HeadVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList TailVisContainerPosition2PtrList ();
extern int LengthVisContainerPosition2PtrList ();
extern VisContainerPosition2Ptr IthElemVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList CopyVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList AppVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList AppElVisContainerPosition2PtrList ();
extern void InsertAfterVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList OrderedInsertVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrListPtr RefEndConsVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrListPtr RefEndAppVisContainerPosition2PtrList ();
extern int ElemInVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList AddToSetVisContainerPosition2PtrList ();
extern VisContainerPosition2PtrList MapVisContainerPosition2PtrList ();
extern int CompVisContainerPosition2PtrList ();
extern VisContainerPosition2Ptr SumVisContainerPosition2PtrList ();

#endif

#ifdef MONITOR
#define DAPTO_RESULTVisContainerPosition2PtrList(l) DAPTO_RESULT_PTR(l)
#define DAPTO_ARGVisContainerPosition2PtrList(l)    DAPTO_ARG_PTR (l, VisContainerPosition2PtrList)
#endif

#endif
