
#include <tcl.h>
#include <tk.h>
#include <stdio.h>
#include <stdlib.h>
#include "tcl_vpt.h"
#include "BasicTypes.h"

extern int Tclinter_Init(Tcl_Interp *interp);

extern "C" int InitApplication(Tcl_Interp *interp)
{
  TclVP_registerVoidPointerType();
  if (Tcl_Init(interp) == TCL_ERROR) return TCL_ERROR;
  if (Tk_Init(interp) == TCL_ERROR) return TCL_ERROR;
  if (Basictypes_Init(interp) == TCL_ERROR) return TCL_ERROR;
  if (Tclinter_Init(interp) == TCL_ERROR) return TCL_ERROR;
  return TCL_OK;
}


void Model_Init();

int PROG_IS_EXITING = 0;

void myExitProc() {
  PROG_IS_EXITING = 1;
}


int getFilenameStart(char *path)
{
  int pos = strlen(path);
  for(;;) {
    if (path[pos] == '/' || path[pos] == '\\') return pos+1;
    if (pos==0) return 0;
    pos--;
  }
}

char *substCygdrive(char *path)
{
  if (memcmp("/cygdrive/",path, 10)==0) {
    char *newString = new char[strlen(path)];
    newString[0] = path[10]; // drive-char
    newString[1] = ':';
    strcpy(newString+2, path+11);
    return newString;
  }
  else {
    return path;
  }
}

char *replaceFilename(char *path, char *newName)
{
  int filenameStart = getFilenameStart(path);
  char *newString = new char[filenameStart+strlen(newName)+1];
  strcpy(newString, path);
  strcpy(newString+filenameStart, newName);  
  return substCygdrive(newString);
}


int main(int argc, char **argv)
{
  atexit(myExitProc);
  Model_Init();
  
  char **newArgv = new char*[argc+2];
  newArgv[0] = argv[0];
  newArgv[1] = replaceFilename(argv[0], "main.tcl");
  newArgv[2] = "--";
  for(int i=1; i<argc; i++) {
    newArgv[i+2] = argv[i];
  }
  Tk_Main(argc+2, newArgv, InitApplication);
  return 0;
}

