

#include "vlAccess.h"
#include "vlLog.h"

///out-file: vlAccess.h



///public:
VLValue vlGetRootNode()
{
  VLList l;
  l.append("vlAccess::getRootNode");
  return l.eval();
}



///public:
VLValue vlGetValue(VLObjectPointer x)
{
  if (x.isNull()) return VLValue();
  VLList l;
  l.append("c::getValue");
  l.append(x);
  return l.eval();
}


///public:
TreeContext vlGetSubElement(VLObjectPointer x, VLString name)
{
  if (x.isNull()) return VLValue();
  VLList l;
  l.append("c::getSubElement");
  l.append(x);
  l.append(name);
  return l.eval();
}


///public:
VLValue vlGetAttr(VLObjectPointer x, VLString name, VLValue defaultValue)
{
  VLValue result = vlGetAttr(x,name);
  if (result.isNull()) return defaultValue;
  else return result;
}


///public:
VLValue vlGetAttr(VLObjectPointer x, VLString name)
{
  if (x.isNull()) return VLValue();
  VLList l;
  l.append("c::getAttr");
  l.append(x);
  l.append(name);
  return l.eval();
}


///public:
TreeContext vlBefore(TreeContext x) 
{ 
  return x;
}

///public:
TreeContext vlAfter(TreeContext x) 
{ 
  VLList l;
  l.append("c::getSuccessor");
  l.append(x);
  return l.eval();
}

///public:
TreeContext vlSon(TreeContext x) 
{ 
  VLList l;
  l.append("c::getFirst");
  l.append(x);
  return l.eval();
}


///public:
VLString vlGetSimpleName(TreeContext x)
{
  VLList l;
  l.append("::vlDraw::getSimpleName");
  l.append(x);
  return l.eval();
}

///public:
VLString vlGetShortName(TreeContext x)
{
  VLList l;
  l.append("::vlDraw::getShortName");
  l.append(x);
  return l.eval();
}

///public:
VLString vlGetFullName(TreeContext x)
{
  VLList l;
  l.append("::vlDraw::getFullName");
  l.append(x);
  return l.eval();
}


///public:
VLString vlGetRelativeName(TreeContext x, TreeContext base)
{
  VLList l;
  l.append("::vlDraw::getRelativeName");
  l.append(x);
  l.append(base);
  return l.eval();
}


///public:
TreeContext vlGetNamespace(TreeContext x)
{
  VLList l;
  l.append("::vlDraw::getNamespace");
  l.append(x);
  return l.eval();
}


///public:
VLList treePathEval(TreeContext x, VLString pathExpression)
{
  // NOTE: This function is obsolete! Use vlGetList instead!
  return vlGetList(x, pathExpression);
}


///public:
VLList vlGetList(TreeContext x, VLString pathExpression)
{
  VLList l;
  l.append("::treePath::eval");
  l.append(x);
  l.append(pathExpression);
  return l.eval();
}

///public:
VLValue vlGet(TreeContext x, VLString pathExpression)
{
  VLList l;
  l.append("::c::evalSimplePathExpression");
  l.append(x);
  l.append(pathExpression);
  return l.eval();
}

///public:
VLValue vlGetRole(TreeContext x)
{
  VLList l;
  l.append("::c::getRole");
  l.append(x);
  return l.eval();
}
