proc slave {name parent args} {
    set mstructname ::${parent}::
    set cstructname ::${parent}::${name}
    upvar #0 $cstructname cstruct $mstructname mstruct
    set frameargs [initslave $name $mstructname $args]
    set cstruct(id) [eval [subst {$mstruct(path) create window \
	    $cstruct(rootx) $cstruct(rooty) $frameargs }]]
    MDI::setcurrent $name $mstructname
    eval [subst {bind $cstruct(path).system.title <ButtonPress-1>   \
	    {::MDI::startmove $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path).system.title <B1-Motion>       \
	    {::MDI::domove    $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path).system.title <ButtonRelease-1> \
	    {::MDI::endmove   $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path).system.title <Double-1> \
	    {::MDI::maxclient $name $mstructname}}]
    eval [subst {bind $cstruct(path).system <ButtonPress-1>         \
	    {::MDI::startmove $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path).system <B1-Motion>             \
	    {::MDI::domove    $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path).system <ButtonRelease-1>       \
	    {::MDI::endmove   $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path).system.pfile <1>               \
	    {set ::MDI::invokesys \[after $::Mysund_MDI(systemmenudelay) \{tk_popup $cstruct(path).system.pfile.menu \
	    \[winfo rootx $cstruct(userpath)\] \[winfo rooty $cstruct(userpath)\]}\]\}}]
    eval [subst {bind $cstruct(path).system.pfile <Double-1>        \
	    {after cancel \$::MDI::invokesys
             after idle {$mstruct(path).$name.system.pclose invoke}}}]
    eval [subst {bind $cstruct(path) <Enter>  \
	    {::MDI::setclientcursor  $name $parent %x %y}}]
    eval [subst {bind $cstruct(path) <Motion> \
	    {::MDI::setclientcursor  $name $parent %x %y}}]
    eval [subst {bind $cstruct(path) <ButtonPress-1>   \
	    {::MDI::startresize $name $parent %x %y %X %Y}}]
    eval [subst {bind $cstruct(path) <B1-Motion>       \
	    {::MDI::doresize    $name $parent %X %Y}}]
    eval [subst {bind $cstruct(path) <ButtonRelease-1> \
	    {::MDI::endresize   $name $parent %X %Y}}]
    return $mstruct(path).$name.$name
}

#######################################################################
# additional slave initialization
#######################################################################
proc initslave {name parent args} {
     upvar #0 $parent$name cstruct $parent mstruct
     array set cstruct [subst {
           "this"      "$parent$name"
           "path"      "$mstruct(path).$name"
           "master"    "$parent"
           "rootx"     "[expr 0 + [llength $mstruct(clientlist)]*30 ]"
           "rooty"     "[expr 0 + [llength $mstruct(clientlist)]*30 ]"
           "height"    "300"
           "width"     "300"
           "title"     "No title"
           "userpath"  "$mstruct(path).$name.$name"
	   "clientpath" "$mstruct(path).$name.$name"
           "closecmd"  ""
           "minroot"   ""
           "status"    "normal"
	   "userargs"  ""
	   "callback"  ""
           "lastevent" "-1 -1"
           "eventtype" ""}]
     set args [string range $args 1 [expr [string length $args]-2]]
     foreach {option val} $args {
             switch -- $option {
                    -x           {set cstruct(rootx)    $val}
                    -y           {set cstruct(rooty)    $val}
                    -height      {set cstruct(height)   $val}
                    -width       {set cstruct(width)    $val}
                    -closecmd    {set cstruct(closecmd) $val}
                    -tags        {set cstruct(tags)     $val}
                    -title       {set cstruct(title)    $val}
		    -userargs    {set cstruct(userargs) $val}
		    -callback    {set cstruct(callback) $val}
                    }
             }
     frame $cstruct(path) -bd 3 -relief raised
     pack  $cstruct(path) -side top -fill both -expand yes
     frame $cstruct(path).system -bg $::MDI::sysblue -bd 0 -cursor $::MDI::cursor(normal_pointer)
     pack  $cstruct(path).system -side top -fill x -padx 0 -pady 0
           set cb [button $cstruct(path).system.pclose -image pclose -bd 1 -command "::MDI::closeclient $name $parent"]
           set Mb [button $cstruct(path).system.pmax   -image pmax   -bd 1 -command "::MDI::maxclient   $name $parent"]
           set mb [button $cstruct(path).system.pmin   -image pmin   -bd 1 -command "::MDI::minclient   $name $parent"]
           set fb [label  $cstruct(path).system.pfile  -image pfile  -bd 1 -bg $::MDI::sysblue]
           pack $cb -side right -padx 2
           pack $cb $Mb $mb -side right
           pack $fb -side left -padx 2
           set tl [label $cstruct(path).system.title -text $cstruct(title) -anchor w -bd 0 -bg $::MDI::sysblue -fg $::MDI::syswhite -font MDIfont]
           pack $tl -side left
     frame $cstruct(path).$name -cursor $::MDI::cursor(normal_pointer) -bd 0
     pack  $cstruct(path).$name -side top -fill both -expand yes
     menu  $cstruct(path).system.pfile.menu -tearoff false
           $cstruct(path).system.pfile.menu add command -label "Restore"  -command "::MDI::normclient $name $parent" -state disabled
           $cstruct(path).system.pfile.menu add command -label "Move" -state disabled
           $cstruct(path).system.pfile.menu add command -label "Resize" -state disabled
           $cstruct(path).system.pfile.menu add command -label "Minimize" -command "::MDI::minclient $name $parent"
           $cstruct(path).system.pfile.menu add command -label "Maximize" -command "::MDI::maxclient $name $parent"
           $cstruct(path).system.pfile.menu add separator
           $cstruct(path).system.pfile.menu add command -label "Close" -command "$mstruct(path).$name.system.pclose invoke"
           $mstruct(path).menu add command -label $cstruct(title) -command [subst "::MDI::setcurrent $name $parent"]
     set mstruct(clientlist) [lappend mstruct(clientlist) $name]
     set result "-width $cstruct(width) -height $cstruct(height) -window $cstruct(path) -anchor nw"

     return $result
     }



