

namespace eval ::oop {
    set cdata(lastId) 0
}


proc oop::new { {self ""} } {

    if { [empty $self] } {
        variable cdata
        incr cdata(lastId)
        set self "obj$cdata(lastId)"
    }
    upvar ::oop::$self data
    assert { ![info exists data(classes)] } {Object '$self' already exists!}
    set data(classes) "oop"

    return $self
}


proc oop::data {self} {
    assert { [info exists ::oop::${self}(classes)] } {Object '$self' does not exist!}
    uplevel 1 [list upvar ::oop::$self data]
}


proc oop::addClass {self namespace} {
    data $self
    set data(classes) [linsert $data(classes) 0 $namespace]
}



proc oop::call {msg self args} {
    assert { [info exists ::oop::${self}(classes)] } {Object '$self' does not exist!}

    foreach namespace [set ::oop::${self}(classes)] {
        set method "::${namespace}::$msg"
        if { [catch {info args $method }]==0 } {
            return [eval [concat [list $method $self] $args]]
        }
    }
    error "Method '$msg' is not supported by object '$self'. Classes: [set ::oop::${self}(classes)]"
}


proc oop::callArgList {msg self argList} {
    eval [list oop::call $msg $self] $argList
}


proc oop::understands {msg self} {
    data $self
    foreach namespace $data(classes) {
        set method "::${namespace}::$msg"
        if { [catch {info args $method }]==0 } {
            return 1
        }
    }
    return 0
}


proc oop::delete {self} {
    data $self
    unset data
}
