
# Module: quote


namespace eval quote {
    set regexpSpecial [list "*"  "+"  "?"  "."  "|"  "^"  "\$"  "("  ")"  "\["  "\]"  "\{"  "\}"]
}


proc quote::quote {string quote special {escape ""}} {
    # precedes all characters in the list "special" and the character "quote"
    # with the character "quote". If the character "escape" is given, the the
    # characters after the "escape" character are not quoted.

    assert { [string length $quote]==1 }
    assert { [string length $escape]<=1 }

    set result ""
    set special [join $special]

    for {set i 0} {$i < [string length $string]} {incr i} {
        set c [string index $string $i]
        if { [string first $c $special]!=-1 || [string compare $c $quote]==0} {
            append result $quote $c
        } elseif { [string compare $c $escape]==0 } {
            incr i
            append result [string index $string $i]
        } else {
            append result $c
        }
    }
    return $result    
}


proc quote::regexpQuote {string {escape ""}} {
    return [quote $string "\\" $quote::regexpSpecial $escape]
}





